Subject: Re: bug#62204: 30.0.50; Feature Request: treesit-major-mode-hook

From: Yuan Fu <[email-masked]>
Date: Sat, 18 Mar 2023 00:49:02 -0700

Aleksandar Dimitrov <[email-masked]> writes:

>>> Currently, I've found two ways to accomplish loading my functionality for all ts-modes:
>>> 
>>> - enumerate them all and use their respective hooks
>>> - advise something like `treesit-major-mode-setup` to execute my code
>>
>> Isn't it enough to check that the buffer has a treesit parser?
>
> I'm not sure I understand you, so I'll try to provide some code.
>
> I'd like to be able to do something like this:
>
> (defun my-setup ()
>   "Code that depends on the presence of TS")
> (add-hook 'treesit-major-mode-hook 'my-setup)
>
> If I understand you correctly,  I could probably do something like this:
>
> (defmacro add-ts-mode-hook (f)
>   "Add mode hook that only executes in ts modes"
>   `(add-hook 'prog-mode-hook
>             (lambda ()
>               (when (treesit-language-at (point))
>                 (,f)))))
>
> I'd say there's bound to be more people who would like to configure a
> certain behaviour whenever treesit is available, regardless of major
> mode. A macro like the above could be a possible solution, but it
> doesn't feel terribly ergonomic.
>
>> A hooks sounds too blunt and ad-hoc for your purposes, AFAIU.
>
> The reason I want to execute my function in a hook is that it sets
> buffer local variables, and configures buffer-local behaviour, perhaps
> even keybindings. I was under the impression that hooks are the correct
> place to do this.

IIUC, you are trying to do something like

(er/enable-mode-expansions 'clojure-mode 'er/add-clojure-mode-expansions)

right?

But a tree-sitter-based expander doesn’t really depend on any particular
major mode. In essence, they depend on the existence of a tree-sitter
parser in the current buffer. So I suggest that you define a universal
expander (similar to er/expand-word, etc) that checks the existence of a
tree-sitter parser and uses the parser to expand the region, and simply
do nothing if there isn’t a parser.

But to work with tree-sitter, expand-region might need to disable some
of its expanders when a tree-sitter parser is available, in case there’s
some conflict between the existing language-specific expander and the
tree-sitter expander.

Yuan